diff -Naurd cluster-3.0.0.rc2/gfs2/quota/gfs2_quota.h cluster-3.0.0.rc3/gfs2/quota/gfs2_quota.h
--- cluster-3.0.0.rc2/gfs2/quota/gfs2_quota.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/quota/gfs2_quota.h	2009-06-11 11:02:55.000000000 +0200
@@ -58,13 +58,11 @@
 };
 typedef struct commandline commandline_t;
 
-extern char *prog_name;
-
 /*  main.c  */
 
 void do_get_super(int fd, struct gfs2_sb *sb);
 void do_sync(struct gfs2_sbd *sdp, commandline_t *comline);
-void cleanup();
+void cleanup(void);
 void read_superblock(struct gfs2_sb *sb, struct gfs2_sbd *sdp);
 void get_last_quota_id(int fd, uint32_t *max_id);
 int is_valid_quota_list(int fd);
@@ -72,7 +70,7 @@
 				struct gfs2_quota *q);
 inline void write_quota_internal(int fd, unsigned int id, int id_type, 
 				 struct gfs2_quota *q);
-void print_quota_list_warning();
+void print_quota_list_warning(void);
 
 /*  check.c  */
 
diff -Naurd cluster-3.0.0.rc2/gfs2/quota/main.c cluster-3.0.0.rc3/gfs2/quota/main.c
--- cluster-3.0.0.rc2/gfs2/quota/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/quota/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -29,8 +29,6 @@
 
 #define OPTION_STRING ("bdf:g:hkl:mnsu:V")
 
-char *prog_name;
-
 /**
  * This function is for libgfs2's sake.
  */
@@ -46,11 +44,11 @@
 
 /**
  * print_usage - print usage info to the user
- *
+ * @prog_name: The name of this program
  */
 
 static void
-print_usage()
+print_usage(const char *prog_name)
 {
 	printf("Usage:\n");
 	printf("\n");
@@ -153,7 +151,7 @@
 			break;
 
 		case 'h':
-			print_usage();
+			print_usage(argv[0]);
 			exit(EXIT_SUCCESS);
 			break;
 
@@ -841,7 +839,7 @@
 	int fd;
 	uint64_t offset;
 	uint64_t new_value;
-	int error, adj_flag = 0;;
+	int error, adj_flag = 0;
 	char quota_file[BUF_SIZE];
 	char id_str[16];
 	struct stat stat_buf;
@@ -1032,8 +1030,6 @@
     struct gfs2_sbd sbd, *sdp = &sbd;
 	commandline_t comline;
 
-	prog_name = argv[0];
-
 	memset(sdp, 0, sizeof(struct gfs2_sbd));
 	memset(&comline, 0, sizeof(commandline_t));
 
diff -Naurd cluster-3.0.0.rc2/gfs2/tool/gfs2_tool.h cluster-3.0.0.rc3/gfs2/tool/gfs2_tool.h
--- cluster-3.0.0.rc2/gfs2/tool/gfs2_tool.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/tool/gfs2_tool.h	2009-06-11 11:02:55.000000000 +0200
@@ -6,7 +6,6 @@
 #define OUTPUT_K      1
 #define OUTPUT_HUMAN  2
 
-extern char *prog_name;
 extern char *action;
 extern int override;
 extern int expert;
@@ -20,16 +19,6 @@
 void print_counters(int argc, char **argv);
 
 
-/* From df.c */
-
-void print_df(int argc, char **argv);
-
-
-/* From layout.c */
-
-void print_layout(int argc, char **argv);
-
-
 /* From main.c */
 
 void print_usage(void);
@@ -37,20 +26,15 @@
 
 /* From misc.c */
 
-void do_file_flush(int argc, char **argv);
 void do_freeze(int argc, char **argv);
-void margs(int argc, char **argv);
 void print_lockdump(int argc, char **argv);
 void set_flag(int argc, char **argv);
 void print_stat(int argc, char **argv);
 void print_sb(int argc, char **argv);
-void print_args(int argc, char **argv);
 void print_jindex(int argc, char **argv);
 void print_journals(int argc, char **argv);
 void print_rindex(int argc, char **argv);
 void print_quota(int argc, char **argv);
-void print_list(void);
-void do_shrink(int argc, char **argv);
 void do_withdraw(int argc, char **argv);
 
 
diff -Naurd cluster-3.0.0.rc2/gfs2/tool/main.c cluster-3.0.0.rc3/gfs2/tool/main.c
--- cluster-3.0.0.rc2/gfs2/tool/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/tool/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -11,13 +11,15 @@
 #include <limits.h>
 #include <errno.h>
 #include <linux/types.h>
+#include <libintl.h>
+#include <locale.h>
+#define _(String) gettext(String)
 
 #include "copyright.cf"
 
 #include "gfs2_tool.h"
 #include "libgfs2.h"
 
-char *prog_name;
 char *action = NULL;
 int override = FALSE;
 int expert = FALSE;
@@ -26,59 +28,33 @@
 int interval = 1;
 int output_type = OUTPUT_BLOCKS;
 
-static const char *usage[] = {
-	"Clear a flag on a inode\n",
-	"  gfs2_tool clearflag flag <filenames>\n",
-	"\n",
-	"Do a GFS2 specific \"df\":\n",
-	"  gfs2_tool df <mountpoint>\n",
-	"\n",
-	"Freeze a GFS2 cluster:\n",
-	"  gfs2_tool freeze <mountpoint>\n",
-	"\n",
-	"Print the current mount arguments of a mounted filesystem:\n",
-	"  gfs2_tool getargs <mountpoint>\n",
-	"\n",
-	"Get tuneable parameters for a filesystem\n",
-	"  gfs2_tool gettune <mountpoint>\n",
-	"\n",
-	"List the file system's journals:\n",
-	"  gfs2_tool journals <mountpoint>\n",
-	"\n",
-	"List filesystems:\n",
-	"  gfs2_tool list\n",
-	"\n",
-	"Have GFS2 dump its lock state:\n",
-	"  gfs2_tool lockdump <mountpoint> [buffersize]\n",
-	"\n",
-	"Provide arguments for next mount:\n",
-	"  gfs2_tool margs <mountarguments>\n",
-	"\n",
-	"Tune a GFS2 superblock\n",
-	"  gfs2_tool sb <device> proto [newval]\n",
-	"  gfs2_tool sb <device> table [newval]\n",
-	"  gfs2_tool sb <device> ondisk [newval]\n",
-	"  gfs2_tool sb <device> multihost [newval]\n",
-	"  gfs2_tool sb <device> all\n",
-	"\n",
-	"Set a flag on a inode\n",
-	"  gfs2_tool setflag flag <filenames>\n",
-	"\n",
-	"Tune a running filesystem\n",
-	"  gfs2_tool settune <mountpoint> <parameter> <value>\n",
-	"\n",
-	"Shrink a filesystem's inode cache:\n",
-	"  gfs2_tool shrink <mountpoint>\n",
-	"\n",
-	"Unfreeze a GFS2 cluster:\n",
-	"  gfs2_tool unfreeze <mountpoint>\n",
-	"\n",
-	"Print tool version information\n",
-	"  gfs2_tool version\n",
-	"\n",
-	"Withdraw this machine from participating in a filesystem:\n",
-	"  gfs2_tool withdraw <mountpoint>\n",
-	"",
+static const char *usage = {
+	"Clear a flag on a inode\n"
+	"  gfs2_tool clearflag flag <filenames>\n"
+	"Freeze a GFS2 cluster:\n"
+	"  gfs2_tool freeze <mountpoint>\n"
+	"Get tuneable parameters for a filesystem\n"
+	"  gfs2_tool gettune <mountpoint>\n"
+	"List the file system's journals:\n"
+	"  gfs2_tool journals <mountpoint>\n"
+	"Have GFS2 dump its lock state:\n"
+	"  gfs2_tool lockdump <mountpoint> [buffersize]\n"
+	"Tune a GFS2 superblock\n"
+	"  gfs2_tool sb <device> proto [newval]\n"
+	"  gfs2_tool sb <device> table [newval]\n"
+	"  gfs2_tool sb <device> ondisk [newval]\n"
+	"  gfs2_tool sb <device> multihost [newval]\n"
+	"  gfs2_tool sb <device> all\n"
+	"Set a flag on a inode\n"
+	"  gfs2_tool setflag flag <filenames>\n"
+	"Tune a running filesystem\n"
+	"  gfs2_tool settune <mountpoint> <parameter> <value>\n"
+	"Unfreeze a GFS2 cluster:\n"
+	"  gfs2_tool unfreeze <mountpoint>\n"
+	"Print tool version information\n"
+	"  gfs2_tool version\n"
+	"Withdraw this machine from participating in a filesystem:\n"
+	"  gfs2_tool withdraw <mountpoint>\n"
 };
 
 /**
@@ -86,13 +62,9 @@
  *
  */
 
-void
-print_usage(void)
+void print_usage(void)
 {
-	int x;
-
-	for (x = 0; usage[x][0]; x++)
-		printf("%s", usage[x]);
+	puts( _(usage) );
 }
 
 /**
@@ -100,14 +72,10 @@
  *
  */
 
-static void
-print_version(void)
+static void print_version(void)
 {
-	printf("gfs2_tool %s (built %s %s)\n",
-	       RELEASE_VERSION,
-	       __DATE__, __TIME__);
-	printf("%s\n",
-	       REDHAT_COPYRIGHT);
+	printf( _("gfs2_tool " RELEASE_VERSION " (built " __DATE__ " " __TIME__ ")\n"));
+	puts( _(REDHAT_COPYRIGHT "\n") );
 }
 
 /**
@@ -117,8 +85,7 @@
  *
  */
 
-static void
-decode_arguments(int argc, char *argv[])
+static void decode_arguments(int argc, char *argv[])
 {
 	int cont = TRUE;
 	int optchar;
@@ -138,7 +105,7 @@
 
 		case 'h':
 			print_usage();
-			exit(EXIT_SUCCESS);
+			exit(0);
 
 		case 'H':
 			output_type = OUTPUT_HUMAN;
@@ -158,7 +125,7 @@
 
 		case 'V':
 			print_version();
-			exit(EXIT_SUCCESS);
+			exit(0);
 
 		case 'X':
 			expert = TRUE;
@@ -169,15 +136,16 @@
 			break;
 
 		default:
-			die("unknown option: %c\n", optchar);
+			die( _("unknown option: %c\n"), optchar);
 		};
 	}
 
 	if (optind < argc) {
 		action = argv[optind];
 		optind++;
-	} else
-		die("no action specified\n");
+	} else {
+		die( _("no action specified\n"));
+	}
 }
 
 /**
@@ -187,44 +155,34 @@
  *
  */
 
-int
-main(int argc, char *argv[])
+int main(int argc, char *argv[])
 {
-	prog_name = argv[0];
+	setlocale(LC_ALL, "");
+	textdomain("gfs2_tool");
 
 	if (argc < 2) {
 		print_usage();
-		exit(EXIT_SUCCESS);
+		return 0;
 	}
 
 	decode_arguments(argc, argv);
 
 	if (strcmp(action, "clearflag") == 0)
 		set_flag(argc, argv);
-	else if (strcmp(action, "df") == 0)
-		print_df(argc, argv);
 	else if (strcmp(action, "freeze") == 0)
 		do_freeze(argc, argv);
-	else if (strcmp(action, "getargs") == 0)
-		print_args(argc, argv);
 	else if (strcmp(action, "gettune") == 0)
 		get_tune(argc, argv);
 	else if (strcmp(action, "journals") == 0)
 		print_journals(argc, argv);
-	else if (strcmp(action, "list") == 0)
-		print_list();
 	else if (strcmp(action, "lockdump") == 0)
 		print_lockdump(argc, argv);
-	else if (strcmp(action, "margs") == 0)
-		margs(argc, argv);
 	else if (strcmp(action, "sb") == 0)
 		do_sb(argc, argv);
 	else if (strcmp(action, "setflag") == 0)
 		set_flag(argc, argv);
 	else if (strcmp(action, "settune") == 0)
 		set_tune(argc, argv);
-	else if (strcmp(action, "shrink") == 0)
-		do_shrink(argc, argv);
 	else if (strcmp(action, "unfreeze") == 0)
 		do_freeze(argc, argv);
 	else if (strcmp(action, "version") == 0)
@@ -232,8 +190,7 @@
 	else if (strcmp(action, "withdraw") == 0)
 		do_withdraw(argc, argv);
 	else
-		die("unknown action: %s\n",
-		    action);
+		die( _("unknown action: %s\n"), action);
 
-	exit(EXIT_SUCCESS);
+	return 0;
 }
diff -Naurd cluster-3.0.0.rc2/gfs2/tool/Makefile cluster-3.0.0.rc3/gfs2/tool/Makefile
--- cluster-3.0.0.rc2/gfs2/tool/Makefile	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/tool/Makefile	2009-06-11 11:02:55.000000000 +0200
@@ -10,8 +10,7 @@
 include $(OBJDIR)/make/install.mk
 include $(OBJDIR)/make/uninstall.mk
 
-OBJS=	df.o \
-	main.o \
+OBJS=	main.o \
 	misc.o \
 	ondisk.o \
 	sb.o \
diff -Naurd cluster-3.0.0.rc2/gfs2/tool/misc.c cluster-3.0.0.rc3/gfs2/tool/misc.c
--- cluster-3.0.0.rc2/gfs2/tool/misc.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/tool/misc.c	2009-06-11 11:02:55.000000000 +0200
@@ -12,6 +12,8 @@
 #include <limits.h>
 #include <errno.h>
 #include <dirent.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #define __user
 #include <linux/gfs2_ondisk.h>
@@ -21,7 +23,10 @@
 #include "gfs2_tool.h"
 #include "iflags.h"
 
-#define SYS_BASE "/sys/fs/gfs2" /* FIXME: Look in /proc/mounts to find this */
+#ifndef FIFREZE
+#define FIFREEZE        _IOWR('X', 119, int)    /* Freeze */
+#define FITHAW          _IOWR('X', 120, int)    /* Thaw */
+#endif
 
 /**
  * do_freeze - freeze a GFS2 filesystem
@@ -30,37 +35,35 @@
  *
  */
 
-void
-do_freeze(int argc, char **argv)
+void do_freeze(int argc, char **argv)
 {
 	char *command = argv[optind - 1];
-	char *name;
+	int fd;
 
 	if (optind == argc)
 		die("Usage: gfs2_tool %s <mountpoint>\n", command);
 
-	name = mp2fsname2(argv[optind]);
-	if (!name) {
-		fprintf(stderr, "Couldn't find a GFS2 filesystem mounted at %s\n",
+	fd = open(argv[optind], O_NOCTTY|O_RDONLY);
+	if (fd < 0) {
+		fprintf(stderr, _("Couldn't find a GFS2 filesystem mounted at %s\n"),
 				argv[optind]);
 		exit(-1);
 	}
 
 	if (strcmp(command, "freeze") == 0) {
-		if (set_sysfs(name, "freeze", "1")) {
-			fprintf(stderr, "Error writing to sysfs freeze file: %s\n",
+		if (ioctl(fd, FIFREEZE, 0)) {
+			fprintf(stderr, _("Error freezing fs: %s\n"),
 					strerror(errno));
 			exit(-1);
 		}
 	} else if (strcmp(command, "unfreeze") == 0) {
-		if (set_sysfs(name, "freeze", "0")) {
-			fprintf(stderr, "Error writing to sysfs freeze file: %s\n",
+		if (ioctl(fd, FITHAW, 0)) {
+			fprintf(stderr, _("Error thawing fs: %s\n"),
 					strerror(errno));
 			exit(-1);
 		}
 	}
-
-	sync();
+	close(fd);
 }
 
 /**
@@ -70,8 +73,7 @@
  *
  */
 
-void
-print_lockdump(int argc, char **argv)
+void print_lockdump(int argc, char **argv)
 {
 	char path[PATH_MAX];
 	char *name, line[PATH_MAX];
@@ -90,8 +92,7 @@
 		sprintf(debugfs, "/tmp/debugfs.XXXXXX");
 
 		if (!mkdtemp(debugfs)) {
-			fprintf(stderr,
-				"Can't create %s mount point.\n",
+			fprintf(stderr,_("Can't create %s mount point.\n"),
 				debugfs);
 			free(debugfs);
 			exit(-1);
@@ -100,8 +101,8 @@
 		rc = mount("none", debugfs, "debugfs", 0, NULL);
 		if (rc) {
 			fprintf(stderr,
-				"Can't mount debugfs.  "
-				"Maybe your kernel doesn't support it.\n");
+				_("Can't mount debugfs. "
+				"Maybe your kernel doesn't support it.\n"));
 				free(debugfs);
 				exit(-1);
 		}
@@ -117,11 +118,11 @@
 			}
 			fclose(file);
 		} else {
-			fprintf(stderr, "Can't open %s: %s\n", path,
+			fprintf(stderr, _("Can't open %s: %s\n"), path,
 				strerror(errno));
 		}
 	} else {
-		fprintf(stderr, "Unable to locate sysfs for mount point %s.\n",
+		fprintf(stderr, _("Unable to locate sysfs for mount point %s.\n"),
 			argv[optind]);
 	}
 	/* Check if we mounted the debugfs and if so, unmount it. */
@@ -133,29 +134,15 @@
 }
 
 /**
- * margs -
- * @argc:
- * @argv:
- *
- */
-
-void
-margs(int argc, char **argv)
-{
-	die("margs not implemented\n");
-}
-
-/**
  * print_flags - print the flags in a dinode's di_flags field
  * @di: the dinode structure
  *
  */
 
-static void
-print_flags(struct gfs2_dinode *di)
+static void print_flags(struct gfs2_dinode *di)
 {
 	if (di->di_flags) {
-		printf("Flags:\n");
+		printf( _("Flags:\n"));
 		if (di->di_flags & GFS2_DIF_JDATA)
 			printf("  jdata\n");
 		if (di->di_flags & GFS2_DIF_EXHASH)
@@ -167,7 +154,7 @@
 		if (di->di_flags & GFS2_DIF_APPENDONLY)
 			printf("  appendonly\n");
 		if (di->di_flags & GFS2_DIF_NOATIME)
-			printf("  noatime\n");
+			printf( _("  noatime\n"));
 		if (di->di_flags & GFS2_DIF_SYNC)
 			printf("  sync\n");
 		if (di->di_flags & GFS2_DIF_TRUNC_IN_PROG)
@@ -179,8 +166,7 @@
  * Use FS_XXX_FL flags defined in <linux/fs.h> which correspond to
  * GFS2_DIF_XXX
  */
-static unsigned int 
-get_flag_from_name(char *name)
+static unsigned int get_flag_from_name(char *name)
 {
 	if (strncmp(name, "jdata", 5) == 0)
 		return FS_JOURNAL_DATA_FL;
@@ -204,8 +190,7 @@
  * @argv:
  *
  */
-void
-set_flag(int argc, char **argv)
+void set_flag(int argc, char **argv)
 {
 	struct gfs2_dinode di;
 	char *flstr;
@@ -221,91 +206,35 @@
 	set = (strcmp(argv[optind -1], "setflag") == 0) ? 1 : 0;
 	flstr = argv[optind++];
 	if (!(flag = get_flag_from_name(flstr)))
-		die("unrecognized flag %s\n", argv[optind -1]);
+		die( _("unrecognized flag %s\n"), argv[optind -1]);
 	
 	for (; optind < argc; optind++) {
 		fd = open(argv[optind], O_RDONLY);
 		if (fd < 0)
-			die("can't open %s: %s\n", argv[optind], strerror(errno));
+			die( _("can't open %s: %s\n"), argv[optind], strerror(errno));
 		/* first get the existing flags on the file */
 		error = ioctl(fd, FS_IOC_GETFLAGS, &newflags);
 		if (error)
-			die("can't get flags on %s: %s\n", 
+			die( _("can't get flags on %s: %s\n"), 
 			    argv[optind], strerror(errno));
 		newflags = set ? newflags | flag : newflags & ~flag;
 		/* new flags */
 		error = ioctl(fd, FS_IOC_SETFLAGS, &newflags);
 		if (error)
-			die("can't set flags on %s: %s\n", 
+			die( _("can't set flags on %s: %s\n"), 
 			    argv[optind], strerror(errno));
 		close(fd);
 	}
 }
 
 /**
- * print_args -
- * @argc:
- * @argv:
- *
- */
-
-
-void
-print_args(int argc, char **argv)
-{
-	char *fs;
-	DIR *d;
-	struct dirent *de;
-	char path[PATH_MAX];
-	struct gfs2_sbd sbd;
-
-	if (optind == argc)
-		die("Usage: gfs2_tool getargs <mountpoint>\n");
-
-	sbd.path_name = argv[optind];
-	if (check_for_gfs2(&sbd)) {
-		if (errno == EINVAL)
-			fprintf(stderr, "Not a valid GFS2 mount point: %s\n",
-					sbd.path_name);
-		else
-			fprintf(stderr, "%s\n", strerror(errno));
-		exit(-1);
-	}
-	fs = mp2fsname(argv[optind]);
-	if (!fs) {
-		fprintf(stderr, "Couldn't find GFS2 filesystem mounted at %s\n",
-				argv[optind]);
-		exit(-1);
-	}
-
-	memset(path, 0, PATH_MAX);
-	snprintf(path, PATH_MAX - 1, "%s/%s/args/", SYS_BASE, fs);
-
-	d = opendir(path);
-	if (!d)
-		die("can't open %s: %s\n", path, strerror(errno));
-
-	while((de = readdir(d))) {
-		if (de->d_name[0] == '.')
-			continue;
-
-		snprintf(path, PATH_MAX - 1, "args/%s", de->d_name);
-		printf("%s %s\n", de->d_name, get_sysfs(fs, path));
-	}
-
-	closedir(d);
-	
-}
-
-/**
  * print_journals - print out the file system journal information
  * @argc:
  * @argv:
  *
  */
 
-void
-print_journals(int argc, char **argv)
+void print_journals(int argc, char **argv)
 {
 	struct gfs2_sbd sbd;
 	DIR *jindex;
@@ -328,7 +257,7 @@
 		    sbd.path_name, strerror(errno));
 	if (check_for_gfs2(&sbd)) {
 		if (errno == EINVAL)
-			fprintf(stderr, "Not a valid GFS2 mount point: %s\n",
+			fprintf(stderr, _("Not a valid GFS2 mount point: %s\n"),
 					sbd.path_name);
 		else
 			fprintf(stderr, "%s\n", strerror(errno));
@@ -336,11 +265,11 @@
 	}
 	sbd.device_fd = open(sbd.device_name, O_RDONLY);
 	if (sbd.device_fd < 0)
-		die("can't open device %s: %s\n",
+		die( _("can't open device %s: %s\n"),
 		    sbd.device_name, strerror(errno));
 
 	if (mount_gfs2_meta(&sbd)) {
-		fprintf(stderr, "Error mounting GFS2 metafs: %s\n",
+		fprintf(stderr, _("Error mounting GFS2 metafs: %s\n"),
 			strerror(errno));
 		exit(-1);
 	}
@@ -348,7 +277,7 @@
 	sprintf(jindex_name, "%s/jindex", sbd.metafs_path);
 	jindex = opendir(jindex_name);
 	if (!jindex) {
-		die("Can't open %s\n", jindex_name);
+		die( _("Can't open %s\n"), jindex_name);
 	} else {
 		jcount = 0;
 		while ((journal = readdir(jindex))) {
@@ -364,7 +293,7 @@
 			       (unsigned long long)statbuf.st_size / 1048576);
 		}
 
-		printf("%d journal(s) found.\n", jcount);
+		printf( _("%d journal(s) found.\n"), jcount);
 		closedir(jindex);
 	}
 	cleanup_metafs(&sbd);
@@ -373,117 +302,13 @@
 }
 
 /**
- * print_list - print the list of mounted filesystems
- *
- */
-
-#define LIST_SIZE 1048576
-
-void
-print_list(void)
-{
-	char path[PATH_MAX];
-	char s_id[PATH_MAX];
-	char *list, *p;
-	int rv, fd, x = 0, total = 0;
-	DIR *d;
-	struct dirent *de;
-
-	list = malloc(LIST_SIZE);
-	if (!list)
-		die("out of memory\n");
-
-	memset(path, 0, PATH_MAX);
-	snprintf(path, PATH_MAX, "%s", SYS_BASE);
-
-	d = opendir(path);
-	if (!d)
-		die("can't open %s: %s\n", SYS_BASE, strerror(errno));
-
-	while ((de = readdir(d))) {
-		if (de->d_name[0] == '.')
-			continue;
-
-		memset(path, 0, PATH_MAX);
-		snprintf(path, PATH_MAX, "%s/%s/id", SYS_BASE, de->d_name);
-
-		fd = open(path, O_RDONLY);
-		if (fd < 0)
-			die("can't open %s: %s\n", path, strerror(errno));
-
-		memset(s_id, 0, PATH_MAX);
-
-		rv = read(fd, s_id, sizeof(s_id));
-		if (rv < 0)
-			die("can't read %s: %s\n", path, strerror(errno));
-
-		close(fd);
-
-		p = strstr(s_id, "\n");
-		if (p)
-			*p = '\0';
-
-		total += strlen(s_id) + strlen(de->d_name) + 2;
-		if (total > LIST_SIZE)
-			break;
-
-		x += sprintf(list + x, "%s %s\n", s_id, de->d_name);
-
-	}
-
-	closedir(d);
-	printf("%s", list);
-	free(list);
-}
-
-/**
- * do_shrink - shrink the inode cache for a filesystem
- * @argc:
- * @argv:
- *
- */
-
-void
-do_shrink(int argc, char **argv)
-{
-	char *fs;
-	struct gfs2_sbd sbd;
-
-	if (optind == argc)
-		die("Usage: gfs2_tool shrink <mountpoint>\n");
-
-	sbd.path_name = argv[optind];
-	if (check_for_gfs2(&sbd)) {
-		if (errno == EINVAL)
-			fprintf(stderr, "Not a valid GFS2 mount point: %s\n",
-					sbd.path_name);
-		else
-			fprintf(stderr, "%s\n", strerror(errno));
-		exit(-1);
-	}
-	fs = mp2fsname(argv[optind]);
-	if (!fs) {
-		fprintf(stderr, "Couldn't find GFS2 filesystem mounted at %s\n",
-				argv[optind]);
-		exit(-1);
-	}
-	
-	if (set_sysfs(fs, "shrink", "1")) {
-		fprintf(stderr, "Error writing to sysfs shrink file: %s\n",
-				strerror(errno));
-		exit(-1);
-	}
-}
-
-/**
  * do_withdraw - withdraw a GFS2 filesystem
  * @argc:
  * @argv:
  *
  */
 
-void
-do_withdraw(int argc, char **argv)
+void do_withdraw(int argc, char **argv)
 {
 	char *name;
 	struct gfs2_sbd sbd;
@@ -494,7 +319,7 @@
 	sbd.path_name = argv[optind];
 	if (check_for_gfs2(&sbd)) {
 		if (errno == EINVAL)
-			fprintf(stderr, "Not a valid GFS2 mount point: %s\n",
+			fprintf(stderr, _("Not a valid GFS2 mount point: %s\n"),
 					sbd.path_name);
 		else
 			fprintf(stderr, "%s\n", strerror(errno));
@@ -502,13 +327,13 @@
 	}
 	name = mp2fsname(argv[optind]);
 	if (!name) {
-		fprintf(stderr, "Couldn't find GFS2 filesystem mounted at %s\n",
+		fprintf(stderr, _("Couldn't find GFS2 filesystem mounted at %s\n"),
 				argv[optind]);
 		exit(-1);
 	}
 
 	if (set_sysfs(name, "withdraw", "1")) {
-		fprintf(stderr, "Error writing to sysfs withdraw file: %s\n",
+		fprintf(stderr, _("Error writing to sysfs withdraw file: %s\n"),
 				strerror(errno));
 		exit(-1);
 	}
diff -Naurd cluster-3.0.0.rc2/gfs2/tool/sb.c cluster-3.0.0.rc3/gfs2/tool/sb.c
--- cluster-3.0.0.rc2/gfs2/tool/sb.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/tool/sb.c	2009-06-11 11:02:55.000000000 +0200
@@ -13,6 +13,8 @@
 #include <limits.h>
 #include <errno.h>
 #include <ctype.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #include <linux/gfs2_ondisk.h>
 
@@ -34,7 +36,7 @@
  * str_to_hexchar - convert a string consisting of two isxdigits back to hex.
  * Returns: the hex character
  */
-int str_to_hexchar(const char *estring)
+static int str_to_hexchar(const char *estring)
 {
 	int ch = 0;
 
@@ -92,25 +94,25 @@
 		die("can't open %s: %s\n", device, strerror(errno));
 
 	if (newval && !override) {
-		printf("You shouldn't change any of these values if the filesystem is mounted.\n");
-		printf("\nAre you sure? [y/n] ");
+		printf( _("You shouldn't change any of these values if the filesystem is mounted.\n"));
+		printf( _("\nAre you sure? [y/n] "));
 		if(!fgets((char*)input, 255, stdin))
-			die("unable to read from stdin\n");
+			die( _("unable to read from stdin\n"));
 
 		if (input[0] != 'y')
-			die("aborted\n");
+			die( _("aborted\n"));
 
 		printf("\n");
 	}
 
 	if (lseek(fd, GFS2_SB_ADDR * GFS2_BASIC_BLOCK, SEEK_SET) !=
 	    GFS2_SB_ADDR * GFS2_BASIC_BLOCK) {
-		fprintf(stderr, "bad seek: %s from %s:%d: superblock\n",
+		fprintf(stderr, _("bad seek: %s from %s:%d: superblock\n"),
 			strerror(errno), __FUNCTION__, __LINE__);
 		exit(-1);
 	}
 	if (read(fd, buf, GFS2_BASIC_BLOCK) != GFS2_BASIC_BLOCK) {
-		fprintf(stderr, "bad read: %s from %s:%d: superblock\n",
+		fprintf(stderr, _("bad read: %s from %s:%d: superblock\n"),
 			strerror(errno), __FUNCTION__, __LINE__);
 		exit(-1);
 	}
@@ -119,104 +121,104 @@
 
 	if (sb.sb_header.mh_magic != GFS2_MAGIC ||
 	    sb.sb_header.mh_type != GFS2_METATYPE_SB)
-		die("there isn't a GFS2 filesystem on %s\n", device);
+		die( _("there isn't a GFS2 filesystem on %s\n"), device);
 
 	if (strcmp(field, "proto") == 0) {
-		printf("current lock protocol name = \"%s\"\n",
+		printf( _("current lock protocol name = \"%s\"\n"),
 		       sb.sb_lockproto);
 
 		if (newval) {
 			if (strlen(newval) >= GFS2_LOCKNAME_LEN)
-				die("new lockproto name is too long\n");
+				die( _("new lockproto name is too long\n"));
 			strcpy(sb.sb_lockproto, newval);
-			printf("new lock protocol name = \"%s\"\n",
+			printf( _("new lock protocol name = \"%s\"\n"),
 			       sb.sb_lockproto);
 		}
 	} else if (strcmp(field, "table") == 0) {
-		printf("current lock table name = \"%s\"\n",
+		printf( _("current lock table name = \"%s\"\n"),
 		       sb.sb_locktable);
 
 		if (newval) {
 			if (strlen(newval) >= GFS2_LOCKNAME_LEN)
-				die("new locktable name is too long\n");
+				die( _("new locktable name is too long\n"));
 			strcpy(sb.sb_locktable, newval);
-			printf("new lock table name = \"%s\"\n",
+			printf( _("new lock table name = \"%s\"\n"),
 			       sb.sb_locktable);
 		}
 	} else if (strcmp(field, "ondisk") == 0) {
-		printf("current ondisk format = %u\n",
+		printf( _("current ondisk format = %u\n"),
 		       sb.sb_fs_format);
 
 		if (newval) {
 			sb.sb_fs_format = atoi(newval);
-			printf("new ondisk format = %u\n",
+			printf( _("new ondisk format = %u\n"),
 			       sb.sb_fs_format);
 		}
 	} else if (strcmp(field, "multihost") == 0) {
-		printf("current multihost format = %u\n",
+		printf( _("current multihost format = %u\n"),
 		       sb.sb_multihost_format);
 
 		if (newval) {
 			sb.sb_multihost_format = atoi(newval);
-			printf("new multihost format = %u\n",
+			printf( _("new multihost format = %u\n"),
 			       sb.sb_multihost_format);
 		}
 #ifdef GFS2_HAS_UUID
 	} else if (strcmp(field, "uuid") == 0) {
-		printf("current uuid = %s\n", str_uuid(sb.sb_uuid));
+		printf( _("current uuid = %s\n"), str_uuid(sb.sb_uuid));
 
 		if (newval) {
 			int i;
 			unsigned char uuid[16], *cp;
 
 			if (strlen(newval) != 36)
-				die("uuid %s is the wrong length; must be 36 "
-				    "hex characters long.\n", newval);
+				die( _("uuid %s is the wrong length; must be 36 "
+				    "hex characters long.\n"), newval);
 			cp = uuid;
 			for (i = 0; i < 36; i++) {
 				if ((i == 8) || (i == 13) ||
 				    (i == 18) || (i == 23)) {
 					if (newval[i] == '-')
 						continue;
-					die("uuid %s has an invalid format.",
+					die( _("uuid %s has an invalid format."),
 					    newval);
 				}
 				if (!isxdigit(newval[i]))
-					die("uuid %s has an invalid hex "
-					    "digit '%c' at offset %d.\n",
+					die( _("uuid %s has an invalid hex "
+					    "digit '%c' at offset %d.\n"),
 					    newval, newval[i], i + 1);
 				*cp = str_to_hexchar(&newval[i++]);
 				cp++;
 			}
 			memcpy(sb.sb_uuid, uuid, 16);
-			printf("new uuid = %s\n", str_uuid(sb.sb_uuid));
+			printf( _("new uuid = %s\n"), str_uuid(sb.sb_uuid));
 		}
 #endif
 	} else if (strcmp(field, "all") == 0) {
 		gfs2_sb_print(&sb);
 		newval = FALSE;
 	} else
-		die("unknown field %s\n", field);
+		die( _("unknown field %s\n"), field);
 
 	if (newval) {
 		gfs2_sb_out(&sb,(char*) buf);
 
 		if (lseek(fd, GFS2_SB_ADDR * GFS2_BASIC_BLOCK, SEEK_SET) !=
 		    GFS2_SB_ADDR * GFS2_BASIC_BLOCK) {
-			fprintf(stderr, "bad seek: %s from %s:%d: superblock\n",
+			fprintf(stderr, _("bad seek: %s from %s:%d: superblock\n"),
 				strerror(errno), __FUNCTION__, __LINE__);
 			exit(-1);
 		}
 		if (write(fd, buf, GFS2_BASIC_BLOCK) != GFS2_BASIC_BLOCK) {
-			fprintf(stderr, "write error: %s from %s:%d: "
-				"superblock\n", strerror(errno),
+			fprintf(stderr, _("write error: %s from %s:%d: "
+				"superblock\n"), strerror(errno),
 				__FUNCTION__, __LINE__);
 			exit(-1);
 		}
 
 		fsync(fd);
 
-		printf("Done\n");
+		printf( _("Done\n"));
 	}
 
 	close(fd);
diff -Naurd cluster-3.0.0.rc2/gfs2/tool/tune.c cluster-3.0.0.rc3/gfs2/tool/tune.c
--- cluster-3.0.0.rc2/gfs2/tool/tune.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs2/tool/tune.c	2009-06-11 11:02:55.000000000 +0200
@@ -12,6 +12,8 @@
 #include <limits.h>
 #include <errno.h>
 #include <dirent.h>
+#include <libintl.h>
+#define _(String) gettext(String)
 
 #define __user
 
@@ -42,12 +44,12 @@
 	char *value;
 
 	if (optind == argc)
-		die("Usage: gfs2_tool gettune <mountpoint>\n");
+		die( _("Usage: gfs2_tool gettune <mountpoint>\n"));
 
 	sbd.path_name = argv[optind];
 	if (check_for_gfs2(&sbd)) {
 		if (errno == EINVAL)
-			fprintf(stderr, "Not a valid GFS2 mount point: %s\n",
+			fprintf(stderr, _("Not a valid GFS2 mount point: %s\n"),
 					sbd.path_name);
 		else
 			fprintf(stderr, "%s\n", strerror(errno));
@@ -55,7 +57,7 @@
 	}
 	fs = mp2fsname(argv[optind]);
 	if (!fs) {
-		fprintf(stderr, "Couldn't find GFS2 filesystem mounted at %s\n",
+		fprintf(stderr, _("Couldn't find GFS2 filesystem mounted at %s\n"),
 				argv[optind]);
 		exit(-1);
 	}
@@ -64,7 +66,7 @@
 
 	d = opendir(path);
 	if (!d)
-		die("can't open %s: %s\n", path, strerror(errno));
+		die( _("can't open %s: %s\n"), path, strerror(errno));
 
 	while((de = readdir(d))) {
 		if (de->d_name[0] == '.')
@@ -73,13 +75,13 @@
 		if (strcmp(de->d_name, "quota_scale") == 0) {
 			value = get_sysfs(fs, "tune/quota_scale");
 			if (!value) {
-				printf("quota_scale = (Not found: %s)\n",
+				printf( _("quota_scale = (Not found: %s)\n"),
 						strerror(errno));
 				continue;
 			}
 			sscanf(value, "%u %u", &num, &den);
 			ratio = (double)num / den;
-			printf("quota_scale = %.4f   (%u, %u)\n", ratio, num,
+			printf( _("quota_scale = %.4f   (%u, %u)\n"), ratio, num,
 			       den);
 		} else
 			printf("%s = %s\n", de->d_name, get_sysfs(fs, path));
@@ -104,18 +106,18 @@
 	struct gfs2_sbd sbd;
 
 	if (optind == argc)
-		die("Usage: gfs2_tool settune <mountpoint> <parameter> <value>\n");
+		die( _("Usage: gfs2_tool settune <mountpoint> <parameter> <value>\n"));
 	sbd.path_name = argv[optind++];
 	if (optind == argc)
-		die("Usage: gfs2_tool settune <mountpoint> <parameter> <value>\n");
+		die( _("Usage: gfs2_tool settune <mountpoint> <parameter> <value>\n"));
 	param = argv[optind++];
 	if (optind == argc)
-		die("Usage: gfs2_tool settune <mountpoint> <parameter> <value>\n");
+		die( _("Usage: gfs2_tool settune <mountpoint> <parameter> <value>\n"));
 	value = argv[optind++];
 
 	if (check_for_gfs2(&sbd)) {
 		if (errno == EINVAL)
-			fprintf(stderr, "Not a valid GFS2 mount point: %s\n",
+			fprintf(stderr, _("Not a valid GFS2 mount point: %s\n"),
 					sbd.path_name);
 		else
 			fprintf(stderr, "%s\n", strerror(errno));
@@ -123,7 +125,7 @@
 	}
 	fs = mp2fsname(sbd.path_name);
 	if (!fs) {
-		fprintf(stderr, "Couldn't find GFS2 filesystem mounted at %s\n",
+		fprintf(stderr, _("Couldn't find GFS2 filesystem mounted at %s\n"),
 				sbd.path_name);
 		exit(-1);
 	}
@@ -135,7 +137,7 @@
 		value = buf;
 	}
 	if (set_sysfs(fs, strcat(tune_base, param), value)) {
-		fprintf(stderr, "Error writing to sysfs %s tune file: %s\n",
+		fprintf(stderr, _("Error writing to sysfs %s tune file: %s\n"),
 				param, strerror(errno));
 		exit(-1);
 	}
diff -Naurd cluster-3.0.0.rc2/gfs-kernel/src/gfs/gfs.h cluster-3.0.0.rc3/gfs-kernel/src/gfs/gfs.h
--- cluster-3.0.0.rc2/gfs-kernel/src/gfs/gfs.h	2009-05-07 09:29:45.000000000 +0200
+++ cluster-3.0.0.rc3/gfs-kernel/src/gfs/gfs.h	2009-06-11 15:46:20.000000000 +0200
@@ -1,7 +1,7 @@
 #ifndef __GFS_DOT_H__
 #define __GFS_DOT_H__
 
-#define RELEASE_VERSION "3.0.0.rc2"
+#define RELEASE_VERSION "3.0.0.rc3"
 
 #include "lm_interface.h"
 
